#!/usr/bin/bash

USER=''
MODE=''
NICE_PR=''
CHRT_PR=''
LOG_FILE=''
TERM=''
TERM_CMD='/usr/bin/gnome-terminal --wait'
CMD=''

while getopts "u:m:n:r:l:ts" OPTION; do
	case $OPTION in
		'u') USER="$OPTARG" ;;
		'm') MODE="$OPTARG" ;;
		'n') NICE_PR="$OPTARG" ;;
		'r') CHRT_PR="$OPTARG" ;;
		'l') LOG_FILE="$OPTARG" ;;
		't') TERM='Y' ;;
	esac
done

shift $(($OPTIND-1))
OPTIND=1

CMD="$@"

exec 2>&1
exec >>$LOG_FILE

# [ -z "$USER" ] && { echo "variable USER is not set!"; exit 1; }
[ -z "$USER" ] && USER='root'
RUN_SCRIPT=`mktemp /tmp/run_asXXXXX.sh`
chmod 755 $RUN_SCRIPT

if [ -n "$NICE_PR" ]; then
			if [ -n "$TERM" ]; then
cat >$RUN_SCRIPT <<EOF
#!/bin/bash
$CMD
exec $SHELL
EOF
				RUN_CMD="$TERM_CMD -- sudo nice -n $NICE_PR $RUN_SCRIPT"
			else
				RUN_CMD="sudo nice -n $NICE_PR $CMD"
			fi
fi

if [ -n "$CHRT_PR" ]; then
			if [ -n "$TERM" ]; then
cat >$RUN_SCRIPT <<EOF
#!/bin/bash
$CMD
exec $SHELL
EOF
				RUN_CMD="$TERM_CMD -- sudo chrt  $CHRT_PR $RUN_SCRIPT"
			else
				RUN_CMD="sudo chrt $CHRT_PR $CMD"
			fi
fi


if [ -n "$MODE" ]; then
	case $MODE in
		'self')
			if [ -n "$TERM" ]; then
cat >$RUN_SCRIPT <<EOF
#!/bin/bash
$CMD
exec $SHELL
EOF
				RUN_CMD="$TERM_CMD -- $RUN_SCRIPT"
			else
				RUN_CMD="$TERM_CMD -- $CMD"
			fi
			;;
		'su')
			if [ -n "$TERM" ]; then
cat >$RUN_SCRIPT <<EOF
#!/bin/bash
$CMD
exec $SHELL
EOF
				RUN_CMD="$TERM_CMD -- su - $USER -c $RUN_SCRIPT"
			else
				RUN_CMD="$TERM_CMD -- su - $USER -c $CMD"
			fi
			;;
		'sudo')
			if [ -n "$TERM" ]; then
cat >$RUN_SCRIPT <<EOF
#!/bin/bash
$CMD
exec $SHELL
EOF
				RUN_CMD="$TERM_CMD  -- sudo -u $USER $RUN_SCRIPT"
			else
				RUN_CMD="sudo -u $USER $CMD"
			fi
			;;
	esac
fi
echo -e "Run command:\n$RUN_CMD"
$RUN_CMD
STATUS=$?

if [ -f  "$RUN_SCRIPT" ]; then
#	cat $RUN_SCRIPT
	rm -f $RUN_SCRIPT
fi

exit $STATUS
